	.module su.c
	andi R20,0xFE
	

	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 55
; //ICC-AVR application builder : 23.01.2010 22:42:36
; // Target : T2313
; // Crystal: 7.3728Mhz
; 
; #include <iot2313v.h>
; #include <macros.h>
; 
; //    sflag
; #define TX1Complete		   0x01
; #define RX1Complete		   0x02
; 
; 
; #pragma global_register sflag:20 bcnt:21 divt:22 temp:23
; 
; 
; //******************************************************************************	
; #define SetRed() \
; 	PORTB &=~ 0x04;   \
; 	PORTB |= 0x02;   \
; 
; #define SetGreen() \
; 	PORTB &=~ 0x02;   \
; 	PORTB |= 0x04;   \
; 
; #define GetState() \
; 	PORTB |= 0x20; \
; 	PORTB &=~ 0x20; \
; 
; 
; #define Transmitter1On() \
; 	PORTD |= 0x20;   \
; 
; #define Transmitter1Off() \
; 	PORTD &=~ 0x20;   \
; 
; #define Transmitter0On() \
; 	PORTD |= 0x40;   \
; 
; #define Transmitter0Off() \
; 	PORTD &=~ 0x40;   \
; 	
; 
; #define SendUART1() \
; 	TCCR0B = 0x02;   \
; 	asm("clt\n");	 \
; 	asm("ldi R21,0x0A\n");	// set bit count \														
; 	asm("andi R20,0xFE\n");		// reset TX1Complete flag \
; 	
; //******************************************************************************	
; 
; 
; unsigned char sflag, UDR1, temp, bcnt, tm;
; 
; void port_init(void)
; {
	.dbline 56
;  PORTA = 0x07;
	ldi R24,7
	out 0x1b,R24
	.dbline 57
;  DDRA  = 0x00; 
	clr R2
	out 0x1a,R2
	.dbline 59
; 
;  PORTB = 0xDC;
	ldi R24,220
	out 0x18,R24
	.dbline 60
;  DDRB  = 0xA7; 
	ldi R24,167
	out 0x17,R24
	.dbline 62
;  
;  PORTD = 0x1F;
	ldi R24,31
	out 0x12,R24
	.dbline 63
;  DDRD  = 0x72; 
	ldi R24,114
	out 0x11,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 72
; }
; 
; 
; //TIMER0 initialize - prescale:8
; // WGM: CTC
; // desired value: 1Hz
; // actual value: Out of range
; void timer0_init(void)
; {
	.dbline 73
;  TCCR0B = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 74
;  TCNT0 = 0x00; 	//set count
	out 0x32,R2
	.dbline 75
;  OCR0A = 0x5F; 	//set count
	ldi R24,95
	out 0x36,R24
	.dbline 76
;  OCR0B = 0x04; 	//set count
	ldi R24,4
	out 0x3c,R24
	.dbline 77
;  TCCR0A = 0x02; //start timer
	ldi R24,2
	out 0x30,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 26
	rjmp _timer0_compa_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e timer0_compa_isr _timer0_compa_isr fV
	.even
_timer0_compa_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 84
; }
; 
; 
; //       ,    
; #pragma interrupt_handler timer0_compa_isr:14
; void timer0_compa_isr(void)
; {
	.dbline 85
;  asm("ld R0,y+\n");		   // restore SREG
	ld R0,y+
	
	.dbline 86
;  asm("lds R23,_UDR1\n");   // R23 = UDR1
	lds R23,_UDR1
	
	.dbline 87
;  asm("bst R23,0\n");	   // T-flag = bit0 R23
	bst R23,0
	
	.dbline 88
;  asm("bld R0,6\n");		   // T-flag = T-flag in copy SREG
	bld R0,6
	
	.dbline 89
;  asm("st -y,R0\n");		   // store SREG
	st -y,R0
	
	.dbline 90
;  asm("lsr R23\n");		   // shift R23 right
	lsr R23
	
	.dbline 91
;  asm("sts _UDR1,R23\n");   // UDR1 = R23
	sts _UDR1,R23
	
	.dbline 92
;  asm("dec R21\n");		   // decrement bit counter
	dec R21
	
	.dbline 93
;  asm("brne LTCA0\n");	   // if not zero, goto label LTCA0
	brne LTCA0
	
	.dbline 94
;  asm("out 0x33,R21\n");	   // TCCR0B = 0
	out 0x33,R21
	
	.dbline 95
;  Transmitter1Off();		   // 
	cbi 0x12,5
	.dbline 95
	.dbline 96
;  asm("ori R20,0x01\n");	   // set TX1Coplete flag			 
	ori R20,0x01
	
	.dbline 97
;  asm("LTCA0:\n");
	LTCA0:
	
	.dbline -2
L3:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 28
	rjmp _timer0_compb_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e timer0_compb_isr _timer0_compb_isr fV
	.even
_timer0_compb_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 103
; }
; 
; 
; #pragma interrupt_handler timer0_compb_isr:15
; void timer0_compb_isr(void)
; {
	.dbline 104
;  asm("in R23,0x12\n");	   // R23 = PORTD
	in R23,0x12
	
	.dbline 105
;  asm("bld R23,0x04\n");	   // TX1 = T-flag
	bld R23,0x04
	
	.dbline 106
;  asm("cpi R21,0x01\n");	   // check bit counter
	cpi R21,0x01
	
	.dbline 107
;  asm("brne LTCB0\n");	   // if not ztro, goto label LTCB0
	brne LTCB0
	
	.dbline 108
;  asm("ori R23,0x10\n");	   // set TX1 to 1, for transmite stop-bit
	ori R23,0x10
	
	.dbline 109
;  asm("LTCB0:\n");
	LTCB0:
	
	.dbline 110
;  asm("out 0x12,R23\n");	   // PORTD = R23
	out 0x12,R23
	
	.dbline -2
L4:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 118
; }
; 
; 
; //UART0 initialize
; // desired baud rate: 9600
; // actual: baud rate:9600 (0,0%)
; void uart0_init(void)
; {
	.dbline 119
;  UCSRB = 0x00; //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 120
;  UBRRH = 0x00; //set baud rate upper
	out 0x2,R2
	.dbline 121
;  UBRRL = 0x2F; //set baud rate lower
	ldi R24,47
	out 0x9,R24
	.dbline 122
;  UCSRA = 0x00;
	out 0xb,R2
	.dbline 123
;  UCSRC = 0x06;
	ldi R24,6
	out 0x3,R24
	.dbline 124
;  UCSRB = 0xD8; //enable
	ldi R24,216
	out 0xa,R24
	.dbline -2
L5:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 14
	rjmp _uart0_rx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e uart0_rx_isr _uart0_rx_isr fV
	.even
_uart0_rx_isr::
	st -y,R2
	st -y,R24
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 130
; }
; 
; 
; #pragma interrupt_handler uart0_rx_isr:8
; void uart0_rx_isr(void)
; {
	.dbline 131
;  UDR1 = UDR;
	in R2,0xc
	sts _UDR1,R2
	.dbline 132
;  sflag &=~ TX1Complete;
	andi R20,254
	.dbline 133
;  SendUART1();
	ldi R24,2
	out 0x33,R24
	.dbline 133
	clt
	
	.dbline 133
	ldi R21,0x0A
	
	.dbline 133
	.dbline -2
L6:
	ld R2,y+
	out 0x3f,R2
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 18
	rjmp _uart0_tx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e uart0_tx_isr _uart0_tx_isr fV
	.even
_uart0_tx_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 139
; }
; 
; 
; #pragma interrupt_handler uart0_tx_isr:10
; void uart0_tx_isr(void)
; {
	.dbline 140
;  NOP();//character has been transmitted
	nop
	.dbline 141
;  Transmitter0Off();
	cbi 0x12,6
	.dbline 141
	.dbline -2
L7:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 4
	rjmp _int1_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e int1_isr _int1_isr fV
	.even
_int1_isr::
	st -y,R2
	st -y,R24
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 147
	.dbline 148
	sbrs R20,0
	rjmp L9
	.dbline 149
	.dbline 150
	clr R2
	out 0x3b,R2
	.dbline 151
	ldi R24,210
	out 0x32,R24
	.dbline 153
	ldi R24,2
	out 0x33,R24
	.dbline 154
	ldi R24,130
	out 0x39,R24
	.dbline 155
	ldi R21,9
	.dbline 156
L9:
	.dbline -2
L8:
	ld R2,y+
	out 0x3f,R2
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	st -y,R24
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 162
; }
; 
; 
; #pragma interrupt_handler int1_isr:3
; void int1_isr(void)
; {
;  if(sflag & TX1Complete)  	//    
;  {
;   GIMSK = 0;				//   INT1
;   TCNT0 = 0xD2;				// set count
; //  TCCR0A = 0x02;			// set WGM mode
;   TCCR0B = 0x02;			// start timer
;   TIMSK = 0x82;				//      0
;   bcnt = 9;					//     
;  }// if(sflag & TX1Complete)
; }
; 
; 
; #pragma interrupt_handler timer0_ovf_isr:7
; void timer0_ovf_isr(void)
; {
	.dbline 163
;  TCNT0 = 0xA4; 			  		//reload counter value
	ldi R24,164
	out 0x32,R24
	.dbline 164
;  asm("lds R23,_UDR1\n");
	lds R23,_UDR1
	
	.dbline 165
;  asm("sec\n");
	sec
	
	.dbline 166
;  asm("sbis 0x10,3\n");
	sbis 0x10,3
	
	.dbline 167
;  asm("clc\n");
	clc
	
	.dbline 168
;  asm("ror R23\n");
	ror R23
	
	.dbline 169
;  asm("sts _UDR1,R23\n");
	sts _UDR1,R23
	
	.dbline 170
;  asm("dec R21\n");
	dec R21
	
	.dbline 171
;  asm("brne LTO0\n");
	brne LTO0
	
	.dbline 174
; 
;  
;  asm("out 0x33,R21\n");	   		// TCCR0B = 0
	out 0x33,R21
	
	.dbline 176
;  
;  sflag |= RX1Complete;
	ori R20,2
	.dbline 189
;  
; // asm("ori R20,0x02\n");			// set RX1Coplete flag	
; 
; /* 
;  TCCR0B = 0x00; //stop timer
;  OCR0A = 0x5F; 		 			//set count
;  OCR0B = 0x04; 					//set count
;  TCCR0A = 0x02; 				//start timer
; 
;  GIMSK = 0x80;		
;  TIMSK = 80; 
; */
;  asm("LTO0:\n");
	LTO0:
	
	.dbline -2
L11:
	ld R24,y+
	out 0x3f,R24
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e timer1_init _timer1_init fV
	.even
_timer1_init::
	.dbline -1
	.dbline 198
; }
; 
; 
; //TIMER1 initialize - prescale:1024
; // WGM: 0) Normal, TOP=0xFFFF
; // desired value: 1Sec
; // actual value:  1,000Sec (0,0%)
; void timer1_init(void)
; {
	.dbline 199
;  TCCR1B = 0x00; //stop timer
	clr R2
	out 0x2e,R2
	.dbline 200
;  TCNT1H = 0xE3; //set count value
	ldi R24,227
	out 0x2d,R24
	.dbline 201
;  TCNT1L = 0xE1;
	ldi R24,225
	out 0x2c,R24
	.dbline 202
;  TCCR1A = 0x00;
	out 0x2f,R2
	.dbline 203
;  TCCR1B = 0x05; //start Timer
	ldi R24,5
	out 0x2e,R24
	.dbline -2
L12:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 10
	rjmp _timer1_ovf_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\su.c
	.dbfunc e timer1_ovf_isr _timer1_ovf_isr fV
	.even
_timer1_ovf_isr::
	st -y,R2
	st -y,R24
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 209
; }
; 
; 
; #pragma interrupt_handler timer1_ovf_isr:6
; void timer1_ovf_isr(void)
; {
	.dbline 211
;  //TIMER1 has overflowed
;  TCNT1H = 0xE3; //reload counter high value
	ldi R24,227
	out 0x2d,R24
	.dbline 212
;  TCNT1L = 0xE1; //reload counter low value
	ldi R24,225
	out 0x2c,R24
	.dbline 214
; 
;  Transmitter1On();			
	sbi 0x12,5
	.dbline 214
	.dbline 215
;  UDR1 = tm;
	lds R2,_tm
	sts _UDR1,R2
	.dbline 216
;  SendUART1();
	ldi R24,2
	out 0x33,R24
	.dbline 216
	clt
	
	.dbline 216
	ldi R21,0x0A
	
	.dbline 216
	.dbline -2
L13:
	ld R2,y+
	out 0x3f,R2
	ld R24,y+
	ld R2,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 222
; }
; 
; 
; //call this routine to initialize all peripherals
; void init_devices(void)
; {
	.dbline 224
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 225
;  port_init();
	rcall _port_init
	.dbline 226
;  timer0_init();
	rcall _timer0_init
	.dbline 227
;  timer1_init();
	rcall _timer1_init
	.dbline 228
;  uart0_init();
	rcall _uart0_init
	.dbline 230
; 
;  MCUCR = 0x08;
	ldi R24,8
	out 0x35,R24
	.dbline 231
;  GIMSK = 0x80;
	ldi R24,128
	out 0x3b,R24
	.dbline 232
;  TIMSK = 0x85;
	ldi R24,133
	out 0x39,R24
	.dbline 233
;  SEI(); //re-enable interrupts
	sei
	.dbline -2
L14:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e GetStatus _GetStatus fV
	.even
_GetStatus::
	.dbline -1
	.dbline 239
;  //all peripherals are now initialized
; }
; 
; 
; void GetStatus(void)
; {
	.dbline 240
;  GetState();
	sbi 0x18,5
	.dbline 240
	cbi 0x18,5
	.dbline 240
	.dbline -2
L15:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
;              i -> <dead>
	.even
_main::
	.dbline -1
	.dbline 245
; }
; 
; 
; void main(void)
; {
	.dbline 248
;  unsigned int i; 
; 
;  tm = 0x55;
	ldi R24,85
	sts _tm,R24
	.dbline 249
;  SetGreen();
	cbi 0x18,1
	.dbline 249
	sbi 0x18,2
	.dbline 249
L17:
	.dbline 253
;  
; l333: 
;  
;  init_devices();
	rcall _init_devices
	.dbline 254
;  sflag = 0x01;
	ldi R20,1
	.dbline 265
;  
; 
;  
; // Transmitter0On();
; // UDR = 0x57;
; 
;  
; // GetStatus();
;  
;   
;  Transmitter1On();		
	sbi 0x12,5
	.dbline 265
	.dbline 266
;  UDR1 = 0x73;
	ldi R24,115
	sts _UDR1,R24
	.dbline 269
; // UDR1 = 0xAA;
; // for(i=74;i>0;i--);
;  SendUART1();
	ldi R24,2
	out 0x33,R24
	.dbline 269
	clt
	
	.dbline 269
	ldi R21,0x0A
	
	.dbline 269
L18:
	.dbline 272
;  
;  do
;  {
	.dbline 274
; 
;   if(sflag & RX1Complete)
	sbrs R20,1
	rjmp L21
	.dbline 275
;   {
	.dbline 277
;      
;    sflag &=~ RX1Complete;
	andi R20,253
	.dbline 278
;    if(0x11 == UDR1) tm++;
	lds R24,_UDR1
	cpi R24,17
	brne L23
	.dbline 278
	lds R24,_tm
	subi R24,255    ; addi 1
	sts _tm,R24
L23:
	.dbline 279
;    SetRed();
	cbi 0x18,2
	.dbline 279
	sbi 0x18,1
	.dbline 279
	.dbline 282
; 
; // CLI(); //disable all interrupts
;  TCCR0B = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 283
;  TCNT0 = 0x00; 	//set count
	out 0x32,R2
	.dbline 284
;  OCR0A = 0x5F; 	//set count
	ldi R24,95
	out 0x36,R24
	.dbline 285
;  OCR0B = 0x04; 	//set count
	ldi R24,4
	out 0x3c,R24
	.dbline 286
;  TCCR0A = 0x02; //start timer
	ldi R24,2
	out 0x30,R24
	.dbline 288
; 
;  MCUCR = 0x08;
	ldi R24,8
	out 0x35,R24
	.dbline 289
;  GIMSK = 0x80;
	ldi R24,128
	out 0x3b,R24
	.dbline 290
;  TIMSK = 0x85;
	ldi R24,133
	out 0x39,R24
	.dbline 297
; // SEI(); //re-enable interrupts
;  //all peripherals are now initialized
;    
;   
; //   Transmitter1On();
; //   UDR1 = tm;
;   }
L21:
	.dbline 299
L19:
	.dbline 299
	rjmp L18
X0:
	.dbline -2
L16:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 i
	.dbend
	.area bss(ram, con, rel)
	.dbfile D:\wn\s\su.c
_tm::
	.blkb 1
	.dbsym e tm _tm c
_UDR1::
	.blkb 1
	.dbsym e UDR1 _UDR1 c
