	.module w.c
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e port_init _port_init fV
	.even
_port_init::
	.dbline -1
	.dbline 50
; //ICC-AVR application builder : 14.02.2010 1:39:47
; // Target : T2313
; // Crystal: 7.3728Mhz
; 
; #include <iot2313v.h>
; #include <macros.h>
; 
; #pragma global_register sflag:20 bcnt:21 UDR1:22 tm:23 
; 
; //    sflag
; #define TX1Complete		   0x01
; #define RX1Complete		   0x02
; 
; //******************************************************************************	
; 
; #define SetRed() \
; 	PORTB &=~ 0x04;   \
; 	PORTB |= 0x02   \
; 
; #define SetGreen() \
; 	PORTB &=~ 0x02;   \
; 	PORTB |= 0x04   \
; 
; 
; #define Transmitter1On(); \
; 	PORTD |= 0x20   	 	\
; 
; #define Transmitter1Off() \
; 	PORTD &=~ 0x20   \
; 
; #define Transmitter0On() \
; 	PORTD |= 0x40   \
; 
; #define Transmitter0Off() \
; 	PORTD &=~ 0x40   \
; 	
; #define StartUART1() \
; 	TCCR0B = 0x02;   \
; 	PORTD &=~ 0x10;  \
; 	bcnt = 0x0A;   \
; 	sflag &=~ TX1Complete   \
; 
; //******************************************************************************	
; 
; 
; 
; unsigned char sflag, bcnt, UDR1, tm;
; 
; void port_init(void)
; {
	.dbline 51
;  PORTA = 0x07;
	ldi R24,7
	out 0x1b,R24
	.dbline 52
;  DDRA  = 0x00; 
	clr R2
	out 0x1a,R2
	.dbline 54
; 
;  PORTB = 0xDA;
	ldi R24,218
	out 0x18,R24
	.dbline 55
;  DDRB  = 0xE7; 
	ldi R24,231
	out 0x17,R24
	.dbline 57
; 
;  PORTD = 0x1F;
	ldi R24,31
	out 0x12,R24
	.dbline 58
;  DDRD  = 0x72; 
	ldi R24,114
	out 0x11,R24
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e timer0_init _timer0_init fV
	.even
_timer0_init::
	.dbline -1
	.dbline 66
; }
; 
; //TIMER0 initialize - prescale:8
; // WGM: Normal
; // desired value: 104uSec
; // actual value: 103,082uSec (0,9%)
; void timer0_init(void)
; {
	.dbline 67
;  TCCR0B = 0x00; //stop timer
	clr R2
	out 0x33,R2
	.dbline 68
;  TCNT0 = 0x00; //set count
	out 0x32,R2
	.dbline 69
;  OCR0A = 0x5F; //set count
	ldi R24,95
	out 0x36,R24
	.dbline 70
;  TCCR0A = 0x02; //start timer
	ldi R24,2
	out 0x30,R24
	.dbline -2
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 12
	rjmp _timer0_ovf_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e timer0_ovf_isr _timer0_ovf_isr fV
	.even
_timer0_ovf_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 76
	.dbline 77
	ldi R23,0xA1
	
	.dbline 78
	out 0x32,R23
	
	.dbline 80
	lsr R22
	.dbline 81
	in R23,0x10
	
	.dbline 82
	bst R23,3
	
	.dbline 83
	bld R22,7
	
	.dbline 85
	dec R21
	.dbline 87
	brne L4
	.dbline 88
	.dbline 89
	out 0x33,R21
	.dbline 90
	out 0x32,R21
	.dbline 92
	ori R20,2
	.dbline 93
L4:
	.dbline -2
L3:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 26
	rjmp _timer0_compa_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e timer0_compa_isr _timer0_compa_isr fV
	.even
_timer0_compa_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 99
; }
; 
; 
; #pragma interrupt_handler timer0_ovf_isr:7
; void timer0_ovf_isr(void)
; {
;  asm("ldi R23,0xA1\n"); 		// new value for TCNT0
;  asm("out 0x32,R23\n");			// reload counter value
; 
;  UDR1 >>= 1;					// shift UDR1 right
;  asm("in R23,0x10\n");			// read PIND in tm
;  asm("bst R23,3\n");			// T-flag = PD3
;  asm("bld R22,7\n");			// bit 7 UDR1 = T-flag
;  
;  bcnt--;
;  
;  if(!bcnt) 
;  {
;   TCCR0B = bcnt;
;   TCNT0 = bcnt;
; //  GIMSK = 0x80;
;   sflag |= RX1Complete;
;  }
; }
; 
; 
; #pragma interrupt_handler timer0_compa_isr:14
; void timer0_compa_isr(void)
; {
	.dbline 100
;  bcnt--; 				   // decrement byte counter
	dec R21
	.dbline 101
;  if(bcnt)				   // if bcnt not equal 0
	breq L7
	.dbline 102
;  {
	.dbline 103
;   asm("bst R22,0\n");	   // T-flag = bit0 UDR1
	bst R22,0
	
	.dbline 104
;   asm("lsr R22\n");	   	   // shift UDR1 right
	lsr R22
	
	.dbline 105
;   tm = PORTD;
	in R23,0x12
	.dbline 106
;   asm("bld R23,0x04\n");   // TX1 pin = T-flag
	bld R23,0x04
	
	.dbline 107
;   if(1 == bcnt)			   // if need send STOP-byte
	cpi R21,1
	brne L9
	.dbline 108
;   {
	.dbline 109
;    tm |= 0x10;			   // set TX1 pin in high
	ori R23,16
	.dbline 110
;   }// if(2 == bcnt)
L9:
	.dbline 111
;   PORTD = tm;			   // write new state into port
	out 0x12,R23
	.dbline 112
;  }
	rjmp L8
L7:
	.dbline 114
	.dbline 115
	out 0x33,R21
	.dbline 116
	cbi 0x12,5
	.dbline 117
	ori R20,1
	.dbline 118
L8:
	.dbline -2
L6:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e uart0_init _uart0_init fV
	.even
_uart0_init::
	.dbline -1
	.dbline 126
;  else
;  {
;   TCCR0B = bcnt;		   // stop timer
;   Transmitter1Off();	   // 
;   sflag |= TX1Complete;	   //
;  }// else
; }
; 
; 
; //UART0 initialize
; // desired baud rate: 9600
; // actual: baud rate:9600 (0,0%)
; void uart0_init(void)
; {
	.dbline 127
;  UCSRB = 0x00; //disable while setting baud rate
	clr R2
	out 0xa,R2
	.dbline 128
;  UBRRH = 0x00; //set baud rate upper
	out 0x2,R2
	.dbline 129
;  UBRRL = 0x2F; //set baud rate lower
	ldi R24,47
	out 0x9,R24
	.dbline 130
;  UCSRA = 0x00;
	out 0xb,R2
	.dbline 131
;  UCSRC = 0x06;
	ldi R24,6
	out 0x3,R24
	.dbline 132
;  UCSRB = 0xD8; //enable
	ldi R24,216
	out 0xa,R24
	.dbline -2
L11:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 14
	rjmp _uart0_rx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e uart0_rx_isr _uart0_rx_isr fV
	.even
_uart0_rx_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 138
; }
; 
; 
; #pragma interrupt_handler uart0_rx_isr:8
; void uart0_rx_isr(void)
; {
	.dbline 140
;  //uart has received a character in UDR
;  NOP();
	nop
	.dbline 141
;  Transmitter1Off();
	cbi 0x12,5
	.dbline -2
L12:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 18
	rjmp _uart0_tx_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e uart0_tx_isr _uart0_tx_isr fV
	.even
_uart0_tx_isr::
	st -y,R0
	in R0,0x3f
	st -y,R0
	.dbline -1
	.dbline 147
; }
; 
; 
; #pragma interrupt_handler uart0_tx_isr:10
; void uart0_tx_isr(void)
; {
	.dbline 149
;  //character has been transmitted
;  NOP();
	nop
	.dbline -2
L13:
	ld R0,y+
	out 0x3f,R0
	ld R0,y+
	.dbline 0 ; func end
	reti
	.dbend
	.area vector(rom, abs)
	.org 4
	rjmp _int1_isr
	.area text(rom, con, rel)
	.dbfile D:\wn\s\w.c
	.dbfunc e int1_isr _int1_isr fV
	.even
_int1_isr::
	st -y,R24
	in R24,0x3f
	st -y,R24
	.dbline -1
	.dbline 155
	.dbline 156
	sbrs R20,0
	rjmp L15
	.dbline 157
	.dbline 159
	ldi R24,210
	out 0x32,R24
	.dbline 160
	ldi R24,2
	out 0x33,R24
	.dbline 161
	ldi R21,9
	.dbline 162
L15:
	.dbline -2
L14:
	ld R24,y+
	out 0x3f,R24
	ld R24,y+
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e init_devices _init_devices fV
	.even
_init_devices::
	.dbline -1
	.dbline 168
; }
; 
; 
; #pragma interrupt_handler int1_isr:3
; void int1_isr(void)
; {
;  if(sflag & TX1Complete)  	//    
;  {
; //  GIMSK = 0;				//   INT1
;   TCNT0 = 0xD2;				// set count
;   TCCR0B = 0x02;			// start timer
;   bcnt = 9;					//     
;  }// if(sflag & TX1Complete)
; }
; 
; 
; //call this routine to initialize all peripherals
; void init_devices(void)
; {
	.dbline 170
;  //stop errant interrupts until set up
;  CLI(); //disable all interrupts
	cli
	.dbline 171
;  port_init();
	rcall _port_init
	.dbline 172
;  timer0_init();
	rcall _timer0_init
	.dbline 173
;  uart0_init();
	rcall _uart0_init
	.dbline 175
; 
;  MCUCR = 0x08;
	ldi R24,8
	out 0x35,R24
	.dbline 176
;  GIMSK = 0x80;
	ldi R24,128
	out 0x3b,R24
	.dbline 177
;  TIMSK = 0x03;
	ldi R24,3
	out 0x39,R24
	.dbline 178
;  SEI(); //re-enable interrupts
	sei
	.dbline -2
L17:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
;              i -> <dead>
	.even
_main::
	.dbline -1
	.dbline 183
;  //all peripherals are now initialized
; }
; 
; void main(void)
; {
	.dbline 186
;  unsigned char i;
;  
;  init_devices();
	rcall _init_devices
	.dbline 188
; 
;  SetGreen();
	cbi 0x18,1
	.dbline 188
	sbi 0x18,2
	.dbline 189
;  sflag = 0x01;
	ldi R20,1
	.dbline 191
;  
;  Transmitter0On();
	sbi 0x12,6
	.dbline 192
;  UDR = 0x67;
	ldi R24,103
	out 0xc,R24
L19:
	.dbline 203
; 
; /* 
;  for(i=141;i>0;i--);
;  
;  Transmitter1On();
;  UDR1 = 0x67;
;  StartUART1();
; */
;  
;  do
;  {
	.dbline 204
L20:
	.dbline 204
	rjmp L19
X0:
	.dbline -2
L18:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
